diff --git a/src/GeomAdaptor/GeomAdaptor_Curve.cxx b/src/GeomAdaptor/GeomAdaptor_Curve.cxx
index 2cb8276460..56c568cff3 100644
--- a/src/GeomAdaptor/GeomAdaptor_Curve.cxx
+++ b/src/GeomAdaptor/GeomAdaptor_Curve.cxx
@@ -24,7 +24,6 @@
 
 #include <Adaptor3d_HCurve.hxx>
 #include <BSplCLib.hxx>
-#include <BSplCLib_Cache.hxx>
 #include <Geom_BezierCurve.hxx>
 #include <Geom_BSplineCurve.hxx>
 #include <Geom_Circle.hxx>
@@ -138,7 +137,8 @@ void GeomAdaptor_Curve::load(const Handle(Geom_Curve)& C,
   myLast  = ULast;
   myCurveCache.Nullify();
 
-  if ( myCurve != C) {
+  if (myCurve != C)
+  {
     myCurve = C;
     myNestedEvaluator.Nullify();
     myBSplineCurve.Nullify();
@@ -524,36 +524,6 @@ Standard_Real GeomAdaptor_Curve::Period() const
   return myCurve->LastParameter() - myCurve->FirstParameter();
 }
 
-//=======================================================================
-//function : RebuildCache
-//purpose  : 
-//=======================================================================
-void GeomAdaptor_Curve::RebuildCache(const Standard_Real theParameter) const
-{
-  if (myTypeCurve == GeomAbs_BezierCurve)
-  {
-    // Create cache for Bezier
-    Handle(Geom_BezierCurve) aBezier = Handle(Geom_BezierCurve)::DownCast(myCurve);
-    Standard_Integer aDeg = aBezier->Degree();
-    TColStd_Array1OfReal aFlatKnots(BSplCLib::FlatBezierKnots(aDeg), 1, 2 * (aDeg + 1));
-    if (myCurveCache.IsNull())
-      myCurveCache = new BSplCLib_Cache(aDeg, aBezier->IsPeriodic(), aFlatKnots,
-        aBezier->Poles(), aBezier->Weights());
-    myCurveCache->BuildCache(theParameter, aDeg, aBezier->IsPeriodic(), aFlatKnots,
-        aBezier->Poles(), aBezier->Weights());
-}
-  else if (myTypeCurve == GeomAbs_BSplineCurve)
-{
-    // Create cache for B-spline
-    if (myCurveCache.IsNull())
-      myCurveCache = new BSplCLib_Cache(myBSplineCurve->Degree(), myBSplineCurve->IsPeriodic(),
-        myBSplineCurve->KnotSequence(), myBSplineCurve->Poles(), myBSplineCurve->Weights());
-    myCurveCache->BuildCache(theParameter, myBSplineCurve->Degree(),
-        myBSplineCurve->IsPeriodic(), myBSplineCurve->KnotSequence(),
-        myBSplineCurve->Poles(), myBSplineCurve->Weights());
-}
-}
-
 //=======================================================================
 //function : IsBoundary
 //purpose  : 
@@ -585,6 +555,34 @@ Standard_Boolean GeomAdaptor_Curve::IsBoundary(const Standard_Real theU,
   return Standard_False;
   }
 
+//=======================================================================
+//function : CreateCache
+//purpose  : 
+//=======================================================================
+
+void GeomAdaptor_Curve::CreateCache() const
+{
+  switch (myTypeCurve)
+  {
+  case GeomAbs_BezierCurve: {
+    // Create cache for Bezier
+    Handle(Geom_BezierCurve) aBezier = Handle(Geom_BezierCurve)::DownCast(myCurve);
+    myCurveCache = new BSplCLib_MultiSpanCache3D(aBezier->Degree(), aBezier->IsPeriodic(),
+        aBezier->Poles(), aBezier->Weights());
+    break;
+  }
+  case GeomAbs_BSplineCurve:
+    // Create cache for B-spline
+    myCurveCache = new BSplCLib_MultiSpanCache3D(
+        myBSplineCurve->Degree(), myBSplineCurve->IsPeriodic(),
+        &myBSplineCurve->Knots(), &myBSplineCurve->Multiplicities(),
+        &myBSplineCurve->KnotSequence(), myBSplineCurve->Poles(), myBSplineCurve->Weights());
+    break;
+  default: // avoid gcc compilation warnings
+    break;
+  }
+}
+
 //=======================================================================
 //function : Value
 //purpose  : 
@@ -611,14 +609,11 @@ void GeomAdaptor_Curve::D0(const Standard_Real U, gp_Pnt& P) const
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD0(U, aStart, aFinish, P);
-    }
     else
   {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D0(U, P);
   }
     break;
@@ -647,14 +642,11 @@ void GeomAdaptor_Curve::D1(const Standard_Real U, gp_Pnt& P, gp_Vec& V) const
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD1(U, aStart, aFinish, P, V);
-    }
     else
   {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D1(U, P, V);
   }
     break;
@@ -684,14 +676,11 @@ void GeomAdaptor_Curve::D2(const Standard_Real U,
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD2(U, aStart, aFinish, P, V1, V2);
-    }
     else
   {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D2(U, P, V1, V2);
   }
     break;
@@ -722,14 +711,11 @@ void GeomAdaptor_Curve::D3(const Standard_Real U,
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD3(U, aStart, aFinish, P, V1, V2, V3);
-    }
     else
   {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D3(U, P, V1, V2, V3);
   }
     break;
diff --git a/src/GeomAdaptor/GeomAdaptor_Curve.hxx b/src/GeomAdaptor/GeomAdaptor_Curve.hxx
index 690480906c..c736720376 100644
--- a/src/GeomAdaptor/GeomAdaptor_Curve.hxx
+++ b/src/GeomAdaptor/GeomAdaptor_Curve.hxx
@@ -23,7 +23,7 @@
 
 #include <GeomAbs_CurveType.hxx>
 #include <Standard_Real.hxx>
-#include <BSplCLib_Cache.hxx>
+#include <BSplCLib_MultiSpanCache.hxx>
 #include <Adaptor3d_Curve.hxx>
 #include <GeomAbs_Shape.hxx>
 #include <Standard_Integer.hxx>
@@ -228,9 +228,8 @@ private:
   //! Check theU relates to start or finish point of B-spline curve and return indices of span the point is located
   Standard_Boolean IsBoundary(const Standard_Real theU, Standard_Integer& theSpanStart, Standard_Integer& theSpanFinish) const;
 
-  //! Rebuilds B-spline cache
-  //! \param theParameter the value on the knot axis which identifies the caching span
-  void RebuildCache (const Standard_Real theParameter) const;
+  //! Allocates memory for a cache object
+  void CreateCache() const;
 
 
   Handle(Geom_Curve) myCurve;
@@ -239,7 +238,7 @@ private:
   Standard_Real myLast;
   
   Handle(Geom_BSplineCurve) myBSplineCurve; ///< B-spline representation to prevent castings
-  mutable Handle(BSplCLib_Cache) myCurveCache; ///< Cached data for B-spline or Bezier curve
+  mutable Handle(BSplCLib_MultiSpanCache3D) myCurveCache; ///< Cached data for B-spline or Bezier curve
   Handle(GeomEvaluator_Curve) myNestedEvaluator; ///< Calculates value of offset curve
 
 
diff --git a/src/GeomAdaptor/GeomAdaptor_Surface.cxx b/src/GeomAdaptor/GeomAdaptor_Surface.cxx
index 24e054270b..ebb65b5312 100644
--- a/src/GeomAdaptor/GeomAdaptor_Surface.cxx
+++ b/src/GeomAdaptor/GeomAdaptor_Surface.cxx
@@ -134,7 +134,8 @@ void GeomAdaptor_Surface::load(const Handle(Geom_Surface)& S,
   myVLast  = VLast;
   mySurfaceCache.Nullify();
 
-  if ( mySurface != S) {
+  if (mySurface != S)
+  {
     mySurface = S;
     myNestedEvaluator.Nullify();
     myBSplineSurface.Nullify();
@@ -179,10 +180,9 @@ void GeomAdaptor_Surface::load(const Handle(Geom_Surface)& S,
         new GeomEvaluator_SurfaceOfExtrusion (aBaseAdaptor, myExtSurf->Direction());
     }
     else if (TheType == STANDARD_TYPE(Geom_BezierSurface))
-    {
       mySurfaceType = GeomAbs_BezierSurface;
-    }
-    else if (TheType == STANDARD_TYPE(Geom_BSplineSurface)) {
+    else if (TheType == STANDARD_TYPE(Geom_BSplineSurface))
+    {
       mySurfaceType = GeomAbs_BSplineSurface;
       myBSplineSurface = Handle(Geom_BSplineSurface)::DownCast(mySurface);
     }
@@ -653,42 +653,34 @@ Standard_Real GeomAdaptor_Surface::VPeriod() const
 }
 
 //=======================================================================
-//function : RebuildCache
+//function : CreateCache
 //purpose  : 
 //=======================================================================
-void GeomAdaptor_Surface::RebuildCache(const Standard_Real theU,
-                                       const Standard_Real theV) const
+
+void GeomAdaptor_Surface::CreateCache() const
 {
-  if (mySurfaceType == GeomAbs_BezierSurface)
+  switch (mySurfaceType)
   {
+  case GeomAbs_BezierSurface: {
     // Create cache for Bezier
     Handle(Geom_BezierSurface) aBezier = Handle(Geom_BezierSurface)::DownCast(mySurface);
-    Standard_Integer aDegU = aBezier->UDegree();
-    Standard_Integer aDegV = aBezier->VDegree();
-    TColStd_Array1OfReal aFlatKnotsU(BSplCLib::FlatBezierKnots(aDegU), 1, 2 * (aDegU + 1));
-    TColStd_Array1OfReal aFlatKnotsV(BSplCLib::FlatBezierKnots(aDegV), 1, 2 * (aDegV + 1));
-    if (mySurfaceCache.IsNull())
-      mySurfaceCache = new BSplSLib_Cache(
-        aDegU, aBezier->IsUPeriodic(), aFlatKnotsU,
-        aDegV, aBezier->IsVPeriodic(), aFlatKnotsV,
+    mySurfaceCache = new BSplSLib_MultiSpanCache(
+        aBezier->UDegree(), aBezier->IsUPeriodic(),
+        aBezier->VDegree(), aBezier->IsVPeriodic(),
         aBezier->Poles(), aBezier->Weights());
-    mySurfaceCache->BuildCache(theU, theV,
-      aDegU, aBezier->IsUPeriodic(), aFlatKnotsU,
-      aDegV, aBezier->IsVPeriodic(), aFlatKnotsV,
-      aBezier->Poles(), aBezier->Weights());
+    break;
   }
-  else if (mySurfaceType == GeomAbs_BSplineSurface)
-  {
+  case GeomAbs_BSplineSurface:
     // Create cache for B-spline
-    if (mySurfaceCache.IsNull())
-      mySurfaceCache = new BSplSLib_Cache(
-        myBSplineSurface->UDegree(), myBSplineSurface->IsUPeriodic(), myBSplineSurface->UKnotSequence(),
-        myBSplineSurface->VDegree(), myBSplineSurface->IsVPeriodic(), myBSplineSurface->VKnotSequence(),
+    mySurfaceCache = new BSplSLib_MultiSpanCache(
+        myBSplineSurface->UDegree(), myBSplineSurface->IsUPeriodic(), &myBSplineSurface->UKnots(),
+        &myBSplineSurface->UMultiplicities(), &myBSplineSurface->UKnotSequence(),
+        myBSplineSurface->VDegree(), myBSplineSurface->IsVPeriodic(), &myBSplineSurface->VKnots(),
+        &myBSplineSurface->VMultiplicities(), &myBSplineSurface->VKnotSequence(),
         myBSplineSurface->Poles(), myBSplineSurface->Weights());
-    mySurfaceCache->BuildCache(theU, theV,
-      myBSplineSurface->UDegree(), myBSplineSurface->IsUPeriodic(), myBSplineSurface->UKnotSequence(),
-      myBSplineSurface->VDegree(), myBSplineSurface->IsVPeriodic(), myBSplineSurface->VKnotSequence(),
-      myBSplineSurface->Poles(), myBSplineSurface->Weights());
+    break;
+  default: // avoid gcc compilation warnings
+    break;
   }
 }
 
@@ -717,8 +709,8 @@ void GeomAdaptor_Surface::D0(const Standard_Real U,
   {
   case GeomAbs_BezierSurface:
   case GeomAbs_BSplineSurface:
-    if (mySurfaceCache.IsNull() || !mySurfaceCache->IsCacheValid(U, V))
-      RebuildCache(U, V);
+    if (mySurfaceCache.IsNull())
+      CreateCache();
     mySurfaceCache->D0(U, V, P);
     break;
 
@@ -747,25 +739,28 @@ void GeomAdaptor_Surface::D1(const Standard_Real U,
                                    gp_Vec&       D1U, 
                                    gp_Vec&       D1V ) const 
 {
-  Standard_Integer Ideb, Ifin, IVdeb, IVfin, USide=0, VSide=0;
   Standard_Real u = U, v = V;
-  if (Abs(U-myUFirst) <= myTolU) {USide= 1; u = myUFirst;}
-  else if (Abs(U-myULast) <= myTolU) {USide= -1; u = myULast;}
-  if (Abs(V-myVFirst) <= myTolV) {VSide= 1; v = myVFirst;}
-  else if (Abs(V-myVLast) <= myTolV) {VSide= -1; v = myVLast;}
 
   switch(mySurfaceType) {
   case GeomAbs_BezierSurface:
   case GeomAbs_BSplineSurface: {
-    if (!myBSplineSurface.IsNull() &&
-        (USide != 0 || VSide != 0) && 
+    Standard_Integer Ideb, Ifin, IVdeb, IVfin, USide = 0, VSide = 0;
+    if (!myBSplineSurface.IsNull())
+    {
+      if (Abs(U - myUFirst) <= myTolU) { USide = 1; u = myUFirst; }
+      else if (Abs(U - myULast) <= myTolU) { USide = -1; u = myULast; }
+      if (Abs(V - myVFirst) <= myTolV) { VSide = 1; v = myVFirst; }
+      else if (Abs(V - myVLast) <= myTolV) { VSide = -1; v = myVLast; }
+    }
+
+    if ((USide != 0 || VSide != 0) && 
         IfUVBound(u, v, Ideb, Ifin, IVdeb, IVfin, USide, VSide))
       myBSplineSurface->LocalD1(u, v, Ideb, Ifin, IVdeb, IVfin, P, D1U, D1V);
     else
     {
-      if (mySurfaceCache.IsNull() || !mySurfaceCache->IsCacheValid(U, V))
-        RebuildCache(U, V);
-      mySurfaceCache->D1(U, V, P, D1U, D1V);
+      if (mySurfaceCache.IsNull())
+        CreateCache();
+      mySurfaceCache->D1(u, v, P, D1U, D1V);
     }
     break;
     }
@@ -797,25 +792,28 @@ void GeomAdaptor_Surface::D2(const Standard_Real U,
                                    gp_Vec&       D2V, 
                                    gp_Vec&       D2UV) const 
 { 
-  Standard_Integer Ideb, Ifin, IVdeb, IVfin, USide=0, VSide=0;
   Standard_Real u = U, v = V;
-  if (Abs(U-myUFirst) <= myTolU) {USide= 1; u = myUFirst;}
-  else if (Abs(U-myULast) <= myTolU) {USide= -1; u = myULast;}
-  if (Abs(V-myVFirst) <= myTolV) {VSide= 1; v = myVFirst;}
-  else if (Abs(V-myVLast) <= myTolV) {VSide= -1; v = myVLast;}
 
   switch(mySurfaceType) {
   case GeomAbs_BezierSurface:
   case  GeomAbs_BSplineSurface: {
-    if (!myBSplineSurface.IsNull() &&
-        (USide != 0 || VSide != 0) && 
+    Standard_Integer Ideb, Ifin, IVdeb, IVfin, USide = 0, VSide = 0;
+    if (!myBSplineSurface.IsNull())
+    {
+      if (Abs(U - myUFirst) <= myTolU) { USide = 1; u = myUFirst; }
+      else if (Abs(U - myULast) <= myTolU) { USide = -1; u = myULast; }
+      if (Abs(V - myVFirst) <= myTolV) { VSide = 1; v = myVFirst; }
+      else if (Abs(V - myVLast) <= myTolV) { VSide = -1; v = myVLast; }
+    }
+
+    if ((USide != 0 || VSide != 0) && 
         IfUVBound(u, v, Ideb, Ifin, IVdeb, IVfin, USide, VSide))
       myBSplineSurface->LocalD2(u, v, Ideb, Ifin, IVdeb, IVfin, P, D1U, D1V, D2U, D2V, D2UV);
     else
     {
-      if (mySurfaceCache.IsNull() || !mySurfaceCache->IsCacheValid(U, V))
-        RebuildCache(U, V);
-      mySurfaceCache->D2(U, V, P, D1U, D1V, D2U, D2V, D2UV);
+      if (mySurfaceCache.IsNull())
+        CreateCache();
+      mySurfaceCache->D2(u, v, P, D1U, D1V, D2U, D2V, D2UV);
     }
     break;
   }
diff --git a/src/GeomAdaptor/GeomAdaptor_Surface.hxx b/src/GeomAdaptor/GeomAdaptor_Surface.hxx
index 2f0d4838c3..303581e213 100644
--- a/src/GeomAdaptor/GeomAdaptor_Surface.hxx
+++ b/src/GeomAdaptor/GeomAdaptor_Surface.hxx
@@ -23,7 +23,7 @@
 
 #include <GeomAbs_SurfaceType.hxx>
 #include <Standard_Real.hxx>
-#include <BSplSLib_Cache.hxx>
+#include <BSplSLib_MultiSpanCache.hxx>
 #include <Adaptor3d_Surface.hxx>
 #include <GeomAbs_Shape.hxx>
 #include <Standard_Integer.hxx>
@@ -256,11 +256,9 @@ private:
   Standard_EXPORT Standard_Boolean IfUVBound (const Standard_Real U, const Standard_Real V, Standard_Integer& Ideb, Standard_Integer& Ifin, Standard_Integer& IVdeb, Standard_Integer& IVfin, const Standard_Integer USide, const Standard_Integer VSide) const;
   
   Standard_EXPORT void load (const Handle(Geom_Surface)& S, const Standard_Real UFirst, const Standard_Real ULast, const Standard_Real VFirst, const Standard_Real VLast, const Standard_Real TolU = 0.0, const Standard_Real TolV = 0.0);
-  
-  //! Rebuilds B-spline cache
-  //! \param theU first parameter to identify the span for caching
-  //! \param theV second parameter to identify the span for caching
-  Standard_EXPORT void RebuildCache (const Standard_Real theU, const Standard_Real theV) const;
+
+  //! Allocates memory for a cache object
+  void CreateCache() const;
 
 
   Handle(Geom_Surface) mySurface;
@@ -272,7 +270,7 @@ private:
   Standard_Real myTolV;
   
   Handle(Geom_BSplineSurface) myBSplineSurface; ///< B-spline representation to prevent downcasts
-  mutable Handle(BSplSLib_Cache) mySurfaceCache; ///< Cached data for B-spline or Bezier surface
+  mutable Handle(BSplSLib_MultiSpanCache) mySurfaceCache; ///< Cached data for B-spline or Bezier surface
 
 protected:
   GeomAbs_SurfaceType mySurfaceType;
diff --git a/src/QABugs/QABugs_19.cxx b/src/QABugs/QABugs_19.cxx
index 36fff1fd04..95b8706a55 100644
--- a/src/QABugs/QABugs_19.cxx
+++ b/src/QABugs/QABugs_19.cxx
@@ -5106,6 +5106,66 @@ static Standard_Integer OCC27065(Draw_Interpretor& di,
   return 0;
 }
 
+//=======================================================================
+//function : OCC27074
+//purpose  : Calculate value of B-spline surface using adaptor with multi-span cache
+//=======================================================================
+static Standard_Integer OCC27074(Draw_Interpretor& theDI, Standard_Integer theArgc, const char** theArgv)
+{
+  if (theArgc < 3 && theArgc > 4)
+  {
+    std::cout << "Incorrect number of arguments. See usage:" << std::endl;
+    theDI.PrintHelp(theArgv[0]);
+    return 1;
+  }
+
+  Handle(Geom_Surface) aSurf = DrawTrSurf::GetSurface(theArgv[1]);
+  GeomAdaptor_Surface anAdaptor(aSurf);
+
+  Standard_Integer aNbValues = Draw::Atoi(theArgv[2]);
+  Standard_Boolean isUseAdaptor = theArgc > 3 && theArgv[3][0] == '-' && theArgv[3][1] == 'a';
+
+  // Number of values to be calculated along each coordinate
+  Standard_Integer aNbU = (Standard_Integer)Sqrt(aNbValues);
+  Standard_Integer aNbV = (Standard_Integer)Ceiling((Standard_Real)aNbValues / aNbU);
+
+  Standard_Real aU1, aU2, aV1, aV2;
+  aSurf->Bounds(aU1, aU2, aV1, aV2);
+
+  Standard_Real aStepU = (aU2 - aU1) / (aNbU - 1);
+  Standard_Real aStepV = (aV2 - aV1) / (aNbV - 1);
+
+  // Calculate values of surface to fill multi-span cache as much as possible.
+  // The parameters are divided to clusters by NxN points. Each time it is calculated
+  // one point from cluster and then the point from next cluster is calculated.
+  Standard_Integer aClusterSize = 100;
+  if (aSurf->DynamicType() == STANDARD_TYPE(Geom_BSplineSurface))
+  {
+    Handle(Geom_BSplineSurface) aBSpl = Handle(Geom_BSplineSurface)::DownCast(aSurf);
+    Standard_Integer aScaleU = aNbU / (aBSpl->NbUKnots() - 1);
+    Standard_Integer aScaleV = aNbV / (aBSpl->NbVKnots() - 1);
+    aClusterSize = Min(aScaleU, aScaleV);
+  }
+
+  Standard_Real aCurU, aCurV;
+  for (Standard_Integer aClusterU = 0; aClusterU < aClusterSize; ++aClusterU)
+    for (Standard_Integer anIndU = aClusterU; anIndU < aNbU; anIndU += aClusterSize)
+    {
+      aCurU = aU1 + aStepU * anIndU;
+      for (Standard_Integer aClusterV = 0; aClusterV < aClusterSize; ++aClusterV)
+        for (Standard_Integer anIndV = aClusterV; anIndV < aNbV; anIndV += aClusterSize)
+        {
+          aCurV = aV1 + aStepV * anIndV;
+          if (isUseAdaptor)
+            anAdaptor.Value(aCurU, aCurV);
+          else
+            aSurf->Value(aCurU, aCurV);
+        }
+    }
+
+  return 0;
+}
+
 //========================================================================
 //function : OCC27318
 //purpose  : Creates a box that is not listed in map of AIS objects of ViewerTest
@@ -5511,6 +5571,10 @@ void QABugs::Commands_19(Draw_Interpretor& theCommands) {
                    "OCC27065 spine profile",
                    __FILE__, OCC27065, group);
 
+  theCommands.Add ("OCC27074",
+                   "OCC27074 surf N [-a]\nCalculate value of surface N times\n(-a means calculation using adaptor)",
+                   __FILE__, OCC27074, group);
+
   theCommands.Add ("OCC27318",
                    "OCC27318: Creates a box that is not listed in map of AIS objects of ViewerTest",
                    __FILE__, OCC27318, group);
diff --git a/tests/blend/simple/Q6 b/tests/blend/simple/Q6
index 1c2a537fa4..01a4f96dbc 100644
--- a/tests/blend/simple/Q6
+++ b/tests/blend/simple/Q6
@@ -3,4 +3,4 @@ tscale s 0 0 0 SCALE
 explode s E
 blend result s SCALE*2 s_5
  
-checkprops result -s 1.65391e+008
+checkprops result -s 1.65391e+08 -eps 1.e-4
diff --git a/tests/bugs/modalg_6/bug25613_1 b/tests/bugs/modalg_6/bug25613_1
index 1f9b9cd322..3f307fe795 100644
--- a/tests/bugs/modalg_6/bug25613_1
+++ b/tests/bugs/modalg_6/bug25613_1
@@ -22,7 +22,7 @@ if { [ expr ($dist - $dist_good) ] < -$Tol } {
   puts "Error in xdistef command (cannot find maximal distance)"
 }
 
-if { $dist > $dist_good } {
+if { $dist > $dist_good + $Tol } {
 #Check if distance found is correct
 
   mkcurve c3d e
diff --git a/tests/bugs/modalg_6/bug25613_2 b/tests/bugs/modalg_6/bug25613_2
index 10dcdf3e47..f0b3ee0d47 100644
--- a/tests/bugs/modalg_6/bug25613_2
+++ b/tests/bugs/modalg_6/bug25613_2
@@ -22,7 +22,7 @@ if { [ expr ($dist - $dist_good) ] < -$Tol } {
   puts "Error in xdistef command (cannot find maximal distance)"
 }
 
-if { $dist > $dist_good } {
+if { $dist > $dist_good + $Tol } {
 #Check if distance found is correct
 
   mkcurve c3d e
diff --git a/tests/de/step_2/R2 b/tests/de/step_2/R2
index cc18f1564c..dbf4b23312 100644
--- a/tests/de/step_2/R2
+++ b/tests/de/step_2/R2
@@ -7,8 +7,8 @@ set ref_data {
 DATA        : Faulties = 0  ( 0 )  Warnings = 0  ( 0 )  Summary  = 0  ( 0 )
 TPSTAT      : Faulties = 0  ( 0 )  Warnings = 31  ( 28 )  Summary  = 31  ( 28 )
 CHECKSHAPE  : Wires    = 0  ( 0 )  Faces    = 0  ( 0 )  Shells   = 0  ( 0 )   Solids   = 0 ( 0 )
-NBSHAPES    : Solid    = 0  ( 0 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   Summary  = 2004  ( 2003 )
-STATSHAPE   : Solid    = 0  ( 0 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   FreeWire = 0  ( 0 )   FreeEdge  = 0 ( 0 )   SharedEdge = 840  ( 839 )
+NBSHAPES    : Solid    = 0  ( 0 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   Summary  = 2005  ( 2003 )
+STATSHAPE   : Solid    = 0  ( 0 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   FreeWire = 0  ( 0 )   FreeEdge  = 0 ( 0 )   SharedEdge = 841  ( 839 )
 TOLERANCE   : MaxTol   = 0.007356791914  ( 0.009485808595 )  AvgTol   =  0.0003528568313  (  0.001207996284 )
 LABELS      : N0Labels = 1  ( 1 )  N1Labels = 0  ( 0 )  N2Labels = 0  ( 0 )   TotalLabels = 1  ( 1 )   NameLabels = 1  ( 1 )   ColorLabels = 1  ( 1 )   LayerLabels = 0  ( 0 )
 PROPS       : Centroid = 0  ( 0 )  Volume   = 0  ( 0 )  Area     = 0  ( 0 )
diff --git a/tests/de/step_2/T1 b/tests/de/step_2/T1
index 7cab7c8f0e..3b32cdc71c 100644
--- a/tests/de/step_2/T1
+++ b/tests/de/step_2/T1
@@ -7,8 +7,8 @@ set ref_data {
 DATA        : Faulties = 0  ( 0 )  Warnings = 0  ( 0 )  Summary  = 0  ( 0 )
 TPSTAT      : Faulties = 0  ( 0 )  Warnings = 31  ( 28 )  Summary  = 31  ( 28 )
 CHECKSHAPE  : Wires    = 0  ( 0 )  Faces    = 0  ( 0 )  Shells   = 0  ( 0 )   Solids   = 0 ( 0 )
-NBSHAPES    : Solid    = 1  ( 1 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   Summary  = 2005  ( 2004 )
-STATSHAPE   : Solid    = 1  ( 1 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   FreeWire = 0  ( 0 )   FreeEdge  = 0 ( 0 )   SharedEdge = 840  ( 839 )
+NBSHAPES    : Solid    = 1  ( 1 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   Summary  = 2006  ( 2004 )
+STATSHAPE   : Solid    = 1  ( 1 )  Shell    = 1  ( 1 )  Face     = 357  ( 357 )   FreeWire = 0  ( 0 )   FreeEdge  = 0 ( 0 )   SharedEdge = 841  ( 839 )
 TOLERANCE   : MaxTol   = 0.007356791914  ( 0.009485808595 )  AvgTol   =  0.0003528126958  (  0.001207999522 )
 LABELS      : N0Labels = 1  ( 1 )  N1Labels = 0  ( 0 )  N2Labels = 0  ( 0 )   TotalLabels = 1  ( 1 )   NameLabels = 1  ( 1 )   ColorLabels = 0  ( 0 )   LayerLabels = 0  ( 0 )
 PROPS       : Centroid = 0  ( 0 )  Volume   = 0  ( 0 )  Area     = 0  ( 0 )
diff --git a/tests/perf/bspline/hugenurbs b/tests/perf/bspline/hugenurbs
new file mode 100644
index 0000000000..9d76b4f339
--- /dev/null
+++ b/tests/perf/bspline/hugenurbs
@@ -0,0 +1,39 @@
+puts "========"
+puts "CR27074"
+puts "========"
+puts ""
+#######################################################################
+# Compare allocated memory for evaluation of huge NURBS surface
+#######################################################################
+
+pload QAcommands
+
+cpulimit 1000
+
+# create simple B-spline
+bsplinesurf s \
+1 2  0 2  1 2 \
+1 2  0 2  1 2 \
+0 0 0 1  1 0 1 1 \
+0 1 0 1  1 1 1 1
+
+# increase number of spans
+set nbspans 1000
+for {set i 1} {$i < $nbspans} {incr i} {
+  set knot [expr double($i) / $nbspans]
+  insertuknot s $knot 1
+  insertvknot s $knot 1
+}
+
+# increase degree
+set deg 5
+incudeg s $deg
+incvdeg s $deg
+
+# calculate values of B-spline
+set nbiter 1000000
+dchrono t reset
+dchrono t start
+OCC27074 s $nbiter -a
+dchrono t stop
+dchrono t show
diff --git a/tests/perf/bspline/multispan b/tests/perf/bspline/multispan
new file mode 100644
index 0000000000..f5f7ca1ad0
--- /dev/null
+++ b/tests/perf/bspline/multispan
@@ -0,0 +1,64 @@
+puts "========"
+puts "CR27074"
+puts "========"
+puts ""
+#######################################################################
+# Compare performance of calculation value of NURBS surface with multi-span cache
+#######################################################################
+
+pload QAcommands
+
+cpulimit 1000
+
+bsplinesurf nsurf \
+5 5 0 6 1 1 4 1 5 1 8 6 \
+5 5 0 6 2 1 3 1 6 1 7 6 \
+0  0  0  1   2  0  0  1   5  0 -1  1   10  0  5  1   12  0  1  1   15  0 -3  1   16  0 -3  1   19  0 -4 1   24  0  0  1 \
+0 10  2  1   3 10  0  1   8 10  5  1   10 10  3  1   12 10  2  1   15 10  0  1   20 10  5  1   21 10  3 1   24 10  0  1 \
+0 20 10  1   4 20  4  1   7 20  4  1   10 20 20  1   12 20 10  1   16 20  4  1   19 20  4  1   20 20 10 1   24 20  0  1 \
+0 30  0  1   2 30  0  1   8 30  0  1   10 30  0  1   12 30  0  1   14 30  0  1   20 30  0  1   22 30  0 1   24 30  0  1 \
+0 40 -1  1   4 40  5  1   9 40  1  1   10 40  5  1   12 40 -1  1   16 40  5  1   21 40  1  1   22 40  5 1   24 40  0  1 \
+0 50  5  1   4 50 10  1   6 50 10  1   10 50  5  1   12 50  5  1   16 50 10  1   18 50 10  1   20 50  5 1   24 50  0  1 \
+0 60  4  1   3 60 -3  1   7 60 -4  1   10 60  4  1   12 60  4  1   15 60 -3  1   19 60 -4  1   20 60  4 1   24 60  0  1 \
+0 70 -5  1   3 70  0  1   5 70  0  1   10 70 -3  1   12 70 -5  1   15 70  0  1   17 70  0  1   20 70 -3 1   24 70  0  1 \
+0 80  7  1   3 80  1  1   7 80  3  1   10 80  0  1   12 80  7  1   15 80  1  1   19 80  3  1   21 80  0 1   24 80  0  1
+
+bsplinesurf rsurf \
+5 5 0 6 1 1 4 1 5 1 8 6 \
+5 5 0 6 2 1 3 1 6 1 7 6 \
+0  0  0  1   2  0  0  1   5  0 -1  1   10  0  5  2   12  0  1  1   15  0 -3  2   16  0 -3  1   19  0 -4 1   24  0  0  1 \
+0 10  2  3   3 10  0  1   8 10  5  3   10 10  3  1   12 10  2  3   15 10  0  1   20 10  5  3   21 10  3 1   24 10  0  2 \
+0 20 10  1   4 20  4  3   7 20  4  2   10 20 20  4   12 20 10  1   16 20  4  3   19 20  4  2   20 20 10 4   24 20  0  1 \
+0 30  0  2   2 30  0  1   8 30  0  1   10 30  0  2   12 30  0  2   14 30  0  1   20 30  0  1   22 30  0 2   24 30  0  3 \
+0 40 -1  1   4 40  5  2   9 40  1  3   10 40  5  2   12 40 -1  1   16 40  5  2   21 40  1  3   22 40  5 2   24 40  0  1 \
+0 50  5  1   4 50 10  5   6 50 10  5   10 50  5  1   12 50  5  1   16 50 10  5   18 50 10  5   20 50  5 1   24 50  0  2 \
+0 60  4  3   3 60 -3  1   7 60 -4  1   10 60  4  1   12 60  4  3   15 60 -3  1   19 60 -4  1   20 60  4 1   24 60  0  1 \
+0 70 -5  5   3 70  0  1   5 70  0  1   10 70 -3  2   12 70 -5  5   15 70  0  1   17 70  0  1   20 70 -3 2   24 70  0  3 \
+0 80  7  1   3 80  1  2   7 80  3  1   10 80  0  1   12 80  7  1   15 80  1  2   19 80  3  1   21 80  0 1   24 80  0  1
+
+
+set surfaces [list nsurf rsurf]
+# number of values to be calculated
+set nbiter 4000000
+
+foreach s $surfaces {
+  # calculate values without adaptor
+  dchrono t reset
+  dchrono t start
+  OCC27074 $s $nbiter
+  dchrono t stop
+  set elapsed [dchrono t show]
+  regexp {CPU user time: ([-0-9.+eE]+) seconds} ${elapsed} full cpu_noadaptor
+
+  # calculate values using adaptor
+  dchrono t reset
+  dchrono t start
+  OCC27074 $s $nbiter -a
+  dchrono t stop
+  set elapsed [dchrono t show]
+  regexp {CPU user time: ([-0-9.+eE]+) seconds} ${elapsed} full cpu_adaptor
+
+  if {$cpu_adaptor >= $cpu_noadaptor} {
+    puts "ERROR: Multi-span cached adaptor is slower than surface"
+  }
+}
-- 
2.22.0.windows.1

